/**
 *  @file IoagrReg.h
 *  @brief This file contains Ioagr Register definitions
 */

/* Copyright 2022-2023 Advanced Micro Devices, Inc. All rights reserved.    */
// SPDX-License-Identifier: MIT

#pragma once

#define SIL_RESERVED_78      22
#define SIL_RESERVED_77      0x400000
#define IOAGR_GLUE_CG_LCLK_CTRL_0_SOFT_OVERRIDE_CLK8_OFFSET      23
#define SIL_RESERVED_76      0x800000
#define SIL_RESERVED_75      24
#define SIL_RESERVED_74      0x1000000
#define SIL_RESERVED_73      25
#define SIL_RESERVED_72      0x2000000
#define SIL_RESERVED_71      26
#define SIL_RESERVED_70      0x4000000
#define SIL_RESERVED_69      27
#define SIL_RESERVED_68      0x8000000
#define SIL_RESERVED_67      28
#define SIL_RESERVED_66      0x10000000
#define SIL_RESERVED_65      29
#define IOAGR_GLUE_CG_LCLK_CTRL_0_SOFT_OVERRIDE_CLK2_MASK        0x20000000
#define SIL_RESERVED_64      30
#define IOAGR_GLUE_CG_LCLK_CTRL_0_SOFT_OVERRIDE_CLK1_MASK        0x40000000
#define SIL_RESERVED_63      31
#define SIL_RESERVED_62      0x80000000

#define SIL_RESERVED_728     0x15b00000UL

#define SIL_RESERVED_93      22
#define IOAGR_GLUE_CG_LCLK_CTRL_1_SOFT_OVERRIDE_CLK9_MASK        0x400000
#define SIL_RESERVED_92      23
#define SIL_RESERVED_91      0x800000
#define SIL_RESERVED_90      24
#define IOAGR_GLUE_CG_LCLK_CTRL_1_SOFT_OVERRIDE_CLK7_MASK        0x1000000
#define SIL_RESERVED_89      25
#define SIL_RESERVED_88      0x2000000
#define SIL_RESERVED_87      26
#define IOAGR_GLUE_CG_LCLK_CTRL_1_SOFT_OVERRIDE_CLK5_MASK        0x4000000
#define SIL_RESERVED_86      27
#define SIL_RESERVED_85      0x8000000
#define SIL_RESERVED_84      28
#define SIL_RESERVED_83      0x10000000
#define SIL_RESERVED_82      29
#define SIL_RESERVED_81      0x20000000
#define SIL_RESERVED_80      30
#define IOAGR_GLUE_CG_LCLK_CTRL_1_SOFT_OVERRIDE_CLK1_MASK        0x40000000
#define SIL_RESERVED_79      31
#define IOAGR_GLUE_CG_LCLK_CTRL_1_SOFT_OVERRIDE_CLK0_MASK        0x80000000

#define SIL_RESERVED_729     0x15b00004UL

#define SIL_RESERVED_95      8
#define SIL_RESERVED_94      0x100
#define SIL_RESERVED_730     0x15b00080UL

#define SIL_RESERVED_538     0x15b00410UL
#define SMN_IOHUB0_N1NBIO0_IOAGR_SION_S0_Client_RdRsp_BurstTarget_Lower_ADDRESS    0x15b00810UL
#define SMN_IOHUB0_N2NBIO0_IOAGR_SION_S0_Client_RdRsp_BurstTarget_Lower_ADDRESS    0x15b00c10UL
#define SIL_RESERVED_646    0x15b01010UL

#define SIL_RESERVED_539    0x15b00414UL
#define SIL_RESERVED_572    0x15b00814UL
#define SIL_RESERVED_611    0x15b00c14UL
#define SMN_IOHUB0_N3NBIO0_IOAGR_SION_S0_Client_RdRsp_BurstTarget_Upper_ADDRESS    0x15b01014UL

#define SIL_RESERVED_540    0x15b00400UL
#define SIL_RESERVED_573    0x15b00800UL
#define SIL_RESERVED_612    0x15b00c00UL
#define SIL_RESERVED_647    0x15b01000UL

#define SIL_RESERVED_541    0x15b00404UL
#define SIL_RESERVED_574    0x15b00804UL
#define SMN_IOHUB0_N2NBIO0_IOAGR_SION_S0_Client_Req_BurstTarget_Upper_ADDRESS    0x15b00c04UL
#define SIL_RESERVED_648    0x15b01004UL

#define SIL_RESERVED_542    0x15b00408UL
#define SIL_RESERVED_575    0x15b00808UL
#define SIL_RESERVED_613    0x15b00c08UL
#define SMN_IOHUB0_N3NBIO0_IOAGR_SION_S0_Client_Req_TimeSlot_Lower_ADDRESS    0x15b01008UL

#define SMN_IOHUB0_N0NBIO0_IOAGR_SION_S0_Client_Req_TimeSlot_Upper_ADDRESS    0x15b0040cUL
#define SIL_RESERVED_576    0x15b0080cUL
#define SIL_RESERVED_614    0x15b00c0cUL
#define SIL_RESERVED_649    0x15b0100cUL

#define SIL_RESERVED_543    0x15b00440UL
#define SIL_RESERVED_577    0x15b00840UL
#define SIL_RESERVED_615    0x15b00c40UL
#define SMN_IOHUB0_N3NBIO0_IOAGR_SION_S1_Client_RdRsp_BurstTarget_Lower_ADDRESS    0x15b01040UL

#define SIL_RESERVED_544    0x15b00444UL
#define SIL_RESERVED_578    0x15b00844UL
#define SIL_RESERVED_616    0x15b00c44UL
#define SMN_IOHUB0_N3NBIO0_IOAGR_SION_S1_Client_RdRsp_BurstTarget_Upper_ADDRESS    0x15b01044UL

#define SMN_IOHUB0_N0NBIO0_IOAGR_SION_S1_Client_Req_BurstTarget_Lower_ADDRESS    0x15b00430UL
#define SIL_RESERVED_579    0x15b00830UL
#define SMN_IOHUB0_N2NBIO0_IOAGR_SION_S1_Client_Req_BurstTarget_Lower_ADDRESS    0x15b00c30UL
#define SIL_RESERVED_650    0x15b01030UL

#define SIL_RESERVED_545    0x15b00434UL
#define SIL_RESERVED_580    0x15b00834UL
#define SIL_RESERVED_617    0x15b00c34UL
#define SIL_RESERVED_651    0x15b01034UL

